package app;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Insets;
import java.io.IOException;
import java.net.URL;

import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;

public final class Guida {
	
	private Guida(){} // non  necessario creare istanze di questa classe
	
	public static void mostra(final Frame parent) {
		
		new Thread(){
			public void run(){
				try{
					Guida.run(parent);
				}catch(IOException e){
					UTIL.dialogoException("Si  verificato un errore. Impossibile visualizzare la guida.", e);
				}
			}
		}.start();
		
	}
	
	private static void run(Frame parent) throws IOException{
		/*
		File f = new File("guida.html");
		URL url = f.toURI().toURL();
		*/
		
		URL url = ClassLoader.getSystemClassLoader().
						getResource("app/guida.html");
		
		JEditorPane pane = new JEditorPane(url);
		pane.setEditable(false);
		pane.setMargin(new Insets(5, 10, 10, 5));
		
		JScrollPane sp = new JScrollPane(pane);
		sp.setPreferredSize(new Dimension(700, 600));
		
		JDialog fin = new JDialog();
		fin.setTitle("Guida al linguaggio di descrizione di una funzione da graficare.");
		fin.setModal(true);
		fin.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		fin.add(sp);
		fin.pack();
		fin.setLocation(UTIL.centerOnScreen(fin.getSize()));
		fin.setVisible(true);
	}

}
