package fdt;

import static app.UTIL.DB;
import static app.UTIL.fase;
import static java.lang.Math.pow;
import static java.lang.Math.sqrt;

/**
 * Un fattore semplice  nella forma (1+as)^m, dove "a"  una frazione, e "m" 
 * la molteplicit del fattore. Se m<0 allora il fattore  un polo, se m>0 il
 * fattore  uno zero.
 * 
 * @author Devil_Dj
 * 
 */
public class FattSemplice extends Fattore {

	private Frazione a;
	private int m;

	public FattSemplice(Frazione a, int m) {
		this.a = a;
		this.m = m;
	}
	
	public double valutaModuloDB(double w) {
		if(m==0) return 0;
		// modulo = rad( 1^2 + (aw)^2)
		double modulo = sqrt( 1 + pow(a.val()*w, 2) );
		return m * DB(modulo);
	}
	
	
	public double valutaFase(double w){
		if(m==0) return 0;
		return m*(fase(1, a.val()*w));
	}
	
	@Override
	public String toString() {
		return "fs, a="+
			a.num + "/" + a.den + "," + 
			"m="+m;
	}

	/**
	 * 
	 * @return il valore di a (gi calcolato)
	 */
	public double getA() {
		// TODO Auto-generated method stub
		return a.val();
	}

	public int getM() {
		// TODO Auto-generated method stub
		return m;
	}

}
















