package fdt;

public abstract class Fattore {
	
	/**
	 * se m>0 questo fattore sar uno zero, se m<0 questo fattore sar un polo.
	 */
	protected int m;
	
	/**
	 * ritorna il modulo in decibel del fattore valutata per w
	 * 
	 * @param w la pulsazione alla quale valutare il modulo
	 * @return il modulo in dB valutato per w
	 */
	public abstract double valutaModuloDB(double w);
	
	/**
	 * ritorna la fase in gradi di questo fattore.
	 * 
	 * @param w
	 *            la pulsazione alla quale valutare la fase
	 * @return la fase valutata per la pulsazione w (in gradi).
	 */
	public abstract double valutaFase(double w);
	
	public abstract String toString();
	

}
