package gui;

import gui.pannelliDiag.PannelloDiagramma;

import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.AbstractAction;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTabbedPane;

@SuppressWarnings("serial")
public class DiagramWindow extends JFrame implements ObserverParametriScala {
	
	private MainWindow mw;
	private JTabbedPane root;
	private int cont;
	
	public DiagramWindow(MainWindow mainWindow) {
		super("Diagrammi tracciati - De Meco Andrea");
		
		this.mw=mainWindow;
		root = new JTabbedPane();
		cont=0;
		
		setContentPane(root);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	}
	
	public void aggiungiDiagramma(final PannelloDiagramma p){
		cont++;
		final TabPanel tabPanel = new TabPanel("Diagramma "+(cont));
		tabPanel.setExportAction(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				ExportHelper.mostraDialogo(p);
			}
		});
		tabPanel.setDeleteAction(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				delete(p);
			}
		});
		tabPanel.addMouseListener(new MouseAdapter() {
			public void mouseReleased(MouseEvent e) {
				if (e.getClickCount() == 2 || e.getButton() == MouseEvent.BUTTON3) {
					String s = JOptionPane.showInputDialog("Nuovo nome "
							+ "per questo grafico:");
					if (s != null && s.length() > 0) {
						tabPanel.rinominaScheda(s);
					}
				}
	
				// ora devo fare questo perch quei bastardi (cornuti deficienti
				// imbranati imbecilli frociazzi dementi figli di puttana
				// zoccola e chi pi ne ha piu ne metta) che hanno progettato
				// swing, hanno "pensato bene" che un componente, per ricevere
				// mouseEvent deve essere in primo piano o non contenere nessun
				// altro componente con un mouselistener implementato. Se un
				// componente che implementa un mouseListener, quindi sta su un
				// tabbed pane, il tabbed pane non ricever piu eventi...
				// nemmeno se cala il signore e la madonna addolorata e si
				// mettono a pregare in aramaico antico. quindi io ora voglio
				// dire solo una cosa ai progettisti di swing NCULU ALLA FISSA
				// DI MAMM vost ca m'ati fattu perdiri 3 ure dovreste morire
				// ammazzati immediatamente.
				root.setSelectedComponent(p);
			}
		});
		root.add(p);
		root.setTabComponentAt(root.getTabCount()-1, tabPanel);
		root.setSelectedIndex(root.getTabCount()-1);
		
	}
	
	public void aggiornaScalaGrafico(int numDec, int logwMin, double fMax,
			double fMin, double mMax, double mMin) {
		int cont = root.getTabCount();
		for(int i=0; i<cont; i++){
			((PannelloDiagramma)root.getComponentAt(i)).aggiornaScalaGrafico
					(numDec, logwMin, fMax, fMin, mMax, mMin);
		}
	}
	
	private void delete(PannelloDiagramma p){
		root.remove(p);
		root.repaint();
		if(root.getTabCount()==0){
			setVisible(false);
			mw.diagWClosed();
		}
	}

}















