package gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

@SuppressWarnings("serial")
public class LabelButton extends JLabel {
	
	private boolean mouseOver;
	private boolean mouseclicked;
	private Action a;
	
	public LabelButton(ImageIcon icon) {
		super(icon);
		Dimension dim = new Dimension(20, 20);
		setPreferredSize(dim);
		setSize(dim);
		
		addMouseListener(new MouseAdapter() {
			public void mouseEntered(MouseEvent e) {
				mouseOver = true;
				mouseclicked = false;
				repaint();
			}
			public void mouseExited(MouseEvent e) {
				mouseOver = false;
				mouseclicked = false;
				repaint();
			}
			public void mousePressed(MouseEvent e) {
				mouseOver = true;
				mouseclicked = true;
				repaint();
			}
			public void mouseReleased(MouseEvent e) {
				mouseclicked = false;
				repaint();
			}
			public void mouseClicked(MouseEvent e) {
				repaint();
				if(a!=null){
					ActionEvent ev = new ActionEvent(LabelButton.this, 0, "");
					a.actionPerformed(ev);
				}
			}
		});
	}
	
	public void setAction(Action a){
		this.a=a;
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		
		if(mouseOver && mouseclicked){
			Graphics2D g2 = (Graphics2D)g;
			Point p1 = new Point(0,0);
			Point p2 = new Point(0, getPreferredSize().height+5);
			Color c1 = Color.white;
			Color c2 = Color.gray;
			GradientPaint gp = new GradientPaint(p1, c2, p2, c1);
			g2.setPaint(gp);
			g2.fillRoundRect(0, 0, getWidth(), getHeight(), 4, 4);
		}else{
			if(mouseOver){
				Graphics2D g2 = (Graphics2D)g;
				Point p1 = new Point(0,0);
				Point p2 = new Point(0, getPreferredSize().height+5);
				Color c1 = Color.white;
				Color c2 = Color.gray;
				GradientPaint gp = new GradientPaint(p1, c1, p2, c2);
				g2.setPaint(gp);
				g2.fillRoundRect(0, 0, getWidth(), getHeight(), 4, 4);
			}
		}
		
		super.paintComponent(g);
	}

}
