package gui;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.Action;
import javax.swing.JLabel;

@SuppressWarnings("serial")
public class LinkLabel extends JLabel {
	
	private Color normal;
	private Action a;
	
	public LinkLabel(String text) {
		super(text);
		normal = getForeground();
		
		addMouseListener(new MouseAdapter() {
			public void mouseEntered(MouseEvent e) {
				setForeground(Color.blue);
			}
			public void mouseExited(MouseEvent e) {
				setForeground(normal);
			}
			public void mouseClicked(MouseEvent e){
				if(a!=null){
					ActionEvent event = new ActionEvent(LinkLabel.this, 0, "");
					a.actionPerformed(event);
				}
			}
		});
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		g.drawLine(1, getSize().height-2, getSize().width-1, getSize().height-2);
	}
	
	public void setAction(Action a){
		this.a=a;
	}
	
	
	
	

}
