package gui;

import java.awt.FlowLayout;

import javax.swing.Action;
import javax.swing.JLabel;
import javax.swing.JPanel;

import app.UTIL;

@SuppressWarnings("serial")
public class TabPanel extends JPanel {
	private JLabel label;
	private LabelButton export;
	private LabelButton close;
	
	public TabPanel(String title) {
		
		FlowLayout l = new FlowLayout(FlowLayout.LEFT);
		l.setVgap(1);
		setLayout(l);
		setFocusable(false);
		setOpaque(false);
		
		setToolTipText("Doppio click per cambiare il nome della scheda");
		
		label = new JLabel(title);
		
		export = new LabelButton(UTIL.getIcon("export.png", 15, 15));
		export.setToolTipText("Esporta...");
		
		close = new LabelButton(UTIL.getIcon("delete.png", 15, 15));
		close.setToolTipText("Chiudi scheda");
		
		add(label);
		add(export);
		add(close);
		
	}

	public void rinominaScheda(String s) {
		label.setText(s);
	}
	
	public void setExportAction(Action a){
		export.setAction(a);
	}
	
	public void setDeleteAction(Action a){
		close.setAction(a);
	}
}

















