package gui.pannelliGestione;

import gui.pannelliGestione.graphicsFdtElem.GraphicFCC;
import gui.pannelliGestione.graphicsFdtElem.GraphicFS;
import gui.pannelliGestione.graphicsFdtElem.GraphicFattore;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public final class EditorGraficoDialogs {
	
	private EditorGraficoDialogs(){}
	
	private static final int orizMargin = 15;
	private static final int supMargin = 25;
	private static final int infMargin = 15;
	private static final int interlinea = 10;
	
	public static double showModificaK(Component parent, double kCorrente){
		String s = JOptionPane.showInputDialog(parent, "<html>Inserisci il guadagno statico:" +
				"<br>(Il separatore per i decimali  il punto)</html>");
		if(s==null || s.length()==0){
			return kCorrente;
		}
		try{
			double k = Double.parseDouble(s);
			return k;
		}catch(Exception e){
			JOptionPane.showMessageDialog(parent, "Valore non valido");
			return kCorrente;
		}
	}

	public static int showModificaH(Component parent, int h) {
		String s = JOptionPane.showInputDialog(parent, 
				"<html>Digita il numero di poli (h&lt;0) o zeri (h&gt;0) nellorigine:" +
				"<br>(Un numero intero, positivo, negativo o nullo)</html>");
		if(s==null){
			return h;
		}
		try{
			int hNew = Integer.parseInt(s);
			return hNew;
		}catch(Exception e){
			JOptionPane.showMessageDialog(parent, "Valore non valido");
			return h;
		}
	}

	public static void showModificaFattore(Component parent,
			GraphicFattore fattore) {
		if(fattore instanceof GraphicFS){
			showFSDialog(parent, (GraphicFS)fattore, false);
		}else if(fattore instanceof GraphicFCC){
			showFCCDialog(parent, (GraphicFCC)fattore, false);
		}
	}
	
	public static GraphicFS showNuovoFS(Component parent){
		GraphicFS result = new GraphicFS(1);
		if(showFSDialog(parent, result, true)){
			return result;
		}else{
			return null;
		}
	}
	
	public static GraphicFCC showNuovoFCC(Component parent){
		GraphicFCC result = new GraphicFCC(1);
		if(showFCCDialog(parent, result, true)){
			return result;
		}else{
			return null;
		}
	}
	
	private static boolean showFSDialog(
			final Component parent, final GraphicFS fs, boolean newFS) {
		
		class BoolWrap { public boolean val; }
		final BoolWrap result = new BoolWrap();
		result.val = false;
		
		String label1Text = "<html>" + (newFS ? "Creazione" : "Modifica") +
			" nuovo fattore semplice nella forma (1 + as)<sup>m</sup><html>";
		String label2Text = "Inserisci il valore di \"a\":";
		String label3Text = "Inserisci il valore di \"m\":";
		String label4Text = 
			"<html>Nota: \"a\" pu essere in forma di numero decimale (il separatore  il punto)" +
			"<br>oppure nella forma di frazione. Il valore di \"m\" deve essere intero, positivo o " +
			"<br>negativo. Sia \"a\" che \"m\" devono essere diversi da zero."+
			"<br>Esempi di valori validi di \"a\": 0.001, -0.1, 1/10, -1/100</html>";
		
		JPanel root = new JPanel(null);
		final JDialog dialog = new JDialog();
		
		JLabel[] labels = new JLabel[4];
		labels[0] = new JLabel(label1Text);
		labels[1] = new JLabel(label2Text);
		labels[2] = new JLabel(label3Text);
		labels[3] = new JLabel(label4Text);
		
		for(JLabel i : labels){
			i.setSize(i.getPreferredSize());
			root.add(i);
		}
		
		final JTextField tfA = new JTextField(newFS ? "" : fs.getTextA());
		tfA.setSize(100, tfA.getPreferredSize().height);
		root.add(tfA);
		
		final JTextField tfM = new JTextField(newFS ? "" : ""+fs.getM());
		tfM.setSize(100, tfM.getPreferredSize().height);
		root.add(tfM);
		
		JButton ok = new JButton("Conferma");
		ok.setSize(ok.getPreferredSize());
		root.add(ok);
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String a = tfA.getText();
				String m = tfM.getText();
				int index = a.indexOf("/");
				double aNum, aDen;
				
				try{
					if(index<0){
						aNum = Double.parseDouble(a);
						if(aNum==0){throw new Exception();}
						aDen = 1.0D;
					}else{
						aNum = Double.parseDouble(a.substring(0, index));
						if(aNum==0){throw new Exception();}
						aDen = Double.parseDouble(a.substring(index+1));
						if(aDen==0){throw new Exception();}
					}
				}catch(Exception exc) {
					JOptionPane.showMessageDialog(parent, "Valore di \"a\" non corretto.");
					return;
				}
				
				int mNum;
				try{
					mNum = Integer.parseInt(m);
					if(mNum==0){throw new Exception();}
				}catch(Exception exc) {
					JOptionPane.showMessageDialog(parent, "Valore di \"m\" non corretto.");
					return;
				}
				
				fs.setNum(aNum);
				fs.setDen(aDen);
				fs.setM(mNum);
				result.val=true;
				dialog.dispose();
				
			}
		});
		
		//posizione componenti
		int x=orizMargin;
		int y=supMargin;
		
		labels[0].setLocation(x, y);
		y+=labels[0].getHeight()+interlinea;
		
		labels[1].setLocation(x, y);
		tfA.setLocation(x+labels[1].getWidth()+interlinea, y);
		y+=labels[1].getHeight()+interlinea;
		
		labels[2].setLocation(x, y);
		tfM.setLocation(x+labels[1].getWidth()+interlinea, y);
		y+=labels[2].getHeight()+interlinea*2;
		
		labels[3].setLocation(x, y);
		y+=labels[3].getHeight()+interlinea;
		
		int wPanel = labels[3].getWidth()+2*orizMargin;
		int xButton = wPanel - orizMargin - ok.getWidth();
		ok.setLocation(xButton, y);
		y+=ok.getHeight();
		
		root.setBorder(BorderFactory.createTitledBorder(
				(newFS ? "Creazione" : "Modifica") + " fattore semplice"));
		root.setPreferredSize(new Dimension(wPanel, y+infMargin));
		
		JPanel contentPane = new JPanel();
		contentPane.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		contentPane.add(root);
		
		dialog.setContentPane(contentPane);
		dialog.setModal(true);
		dialog.setTitle(
				(newFS ? "Creazione" : "Modifica") + " fattore semplice");
		dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		dialog.setResizable(false);
		dialog.pack();
		dialog.setLocationRelativeTo(parent);
		dialog.setVisible(true);
		return result.val;
		
	}

	private static boolean showFCCDialog(final Component parent, final GraphicFCC fcc, boolean newFCC) {
		
		class BoolWrap { public boolean val; }
		final BoolWrap result = new BoolWrap();
		result.val = false;
		
		String label1Text = "<html>" + (newFCC ? "Creazione" : "Modifica") +
			" nuovo fattore complesso nella forma (1 + as + bs<sup>2</sup>)<sup>m</sup><html>";
		String label2Text = "Inserisci il valore di \"a\":";
		String label3Text = "Inserisci il valore di \"b\":";
		String label4Text = "Inserisci il valore di \"m\":";
		String label5Text = 
			"<html>Nota: \"a\" o \"b\" Possono essere in forma di numero decimale (il separatore  il punto)" +
			"<br>oppure nella forma di frazione. Il valore di \"m\" deve essere intero, positivo o " +
			"<br>negativo. Sia \"a\", \"b\" che \"m\" devono essere diversi da zero."+
			"<br>Esempi di valori validi di \"a\": 0.001, -0.1, 1/10, -1/100</html>";
		
		JPanel root = new JPanel(null);
		final JDialog dialog = new JDialog();
		
		JLabel[] labels = new JLabel[5];
		labels[0] = new JLabel(label1Text);
		labels[1] = new JLabel(label2Text);
		labels[2] = new JLabel(label3Text);
		labels[3] = new JLabel(label4Text);
		labels[4] = new JLabel(label5Text);
		
		for(JLabel i : labels){
			i.setSize(i.getPreferredSize());
			root.add(i);
		}
		
		final JTextField tfA = new JTextField(newFCC ? "" : fcc.getTextA());
		tfA.setSize(100, tfA.getPreferredSize().height);
		root.add(tfA);
		
		final JTextField tfB = new JTextField(newFCC ? "" : fcc.getTextB());
		tfB.setSize(100, tfB.getPreferredSize().height);
		root.add(tfB);
		
		final JTextField tfM = new JTextField(newFCC ? "" : ""+fcc.getM());
		tfM.setSize(100, tfM.getPreferredSize().height);
		root.add(tfM);
		
		JButton ok = new JButton("Conferma");
		ok.setSize(ok.getPreferredSize());
		root.add(ok);
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				double aNum, aDen, bNum, bDen;
				int mNum;
				
				String a = tfA.getText();
				int indexA = a.indexOf("/");
				try{
					if(indexA<0){
						aNum = Double.parseDouble(a);
						if(aNum==0){throw new Exception();}
						aDen = 1.0D;
					}else{
						aNum = Double.parseDouble(a.substring(0, indexA));
						if(aNum==0){throw new Exception();}
						aDen = Double.parseDouble(a.substring(indexA+1));
						if(aDen==0){throw new Exception();}
					}
				}catch(Exception exc) {
					JOptionPane.showMessageDialog(parent, "Valore di \"a\" non corretto.");
					return;
				}
				
				String b = tfB.getText();
				int indexB = b.indexOf("/");
				try{
					if(indexB<0){
						bNum = Double.parseDouble(b);
						if(bNum==0){throw new Exception();}
						bDen = 1.0D;
					}else{
						bNum = Double.parseDouble(b.substring(0, indexB));
						if(bNum==0){throw new Exception();}
						bDen = Double.parseDouble(b.substring(indexB+1));
						if(bDen==0){throw new Exception();}
					}
				}catch(Exception exc) {
					JOptionPane.showMessageDialog(parent, "Valore di \"b\" non corretto.");
					return;
				}
				
				String m = tfM.getText();
				try{
					mNum = Integer.parseInt(m);
					if(mNum==0){throw new Exception();}
				}catch(Exception exc) {
					JOptionPane.showMessageDialog(parent, "Valore di \"m\" non corretto.");
					return;
				}
				
				fcc.setNum1(aNum);
				fcc.setDen1(aDen);
				fcc.setNum2(bNum);
				fcc.setDen2(bDen);
				fcc.setM(mNum);
				result.val=true;
				dialog.dispose();
				
			}
		});
		
		//posizione componenti
		int x=orizMargin;
		int y=supMargin;
		
		labels[0].setLocation(x, y);
		y+=labels[0].getHeight()+interlinea;
		
		labels[1].setLocation(x, y);
		tfA.setLocation(x+labels[1].getWidth()+interlinea, y);
		y+=labels[1].getHeight()+interlinea;
		
		labels[2].setLocation(x, y);
		tfB.setLocation(x+labels[1].getWidth()+interlinea, y);
		y+=labels[2].getHeight()+interlinea;
		
		labels[3].setLocation(x, y);
		tfM.setLocation(x+labels[1].getWidth()+interlinea, y);
		y+=labels[3].getHeight()+interlinea*3;
		
		labels[4].setLocation(x, y);
		y+=labels[4].getHeight()+interlinea*2;
		
		int wPanel = labels[4].getWidth()+2*orizMargin;
		int xButton = wPanel - orizMargin - ok.getWidth();
		ok.setLocation(xButton, y);
		y+=ok.getHeight();
		
		root.setBorder(BorderFactory.createTitledBorder(
				(newFCC ? "Creazione" : "Modifica") + " fattore complesso"));
		root.setPreferredSize(new Dimension(wPanel, y+infMargin));
		
		JPanel contentPane = new JPanel();
		contentPane.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		contentPane.add(root);
		
		dialog.setContentPane(contentPane);
		dialog.setModal(true);
		dialog.setTitle(
				(newFCC ? "Creazione" : "Modifica") + " fattore complesso");
		dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		dialog.setResizable(false);
		dialog.pack();
		dialog.setLocationRelativeTo(parent);
		dialog.setVisible(true);
		return result.val;
	}

}

















