package gui.pannelliGestione;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;

import app.UTIL;

@SuppressWarnings("serial")
public class EditorGraficoPanel extends JPanel {
	
	private CanvasFunzione funzione;
	private JScrollPane sp;
	
	private JButton addFS;
	private JButton addFCC;
	private JButton reset;
	private JButton aggiorna;
	
	public EditorGraficoPanel(EditorTextPanel editorTextPanel){
		setLayout(null);
		setBorder(BorderFactory.createTitledBorder("Editor grafico"));
		inizializzaComponenti(editorTextPanel);
		addActionListeners();
		
	}
	
	private void inizializzaComponenti(EditorTextPanel editorTextPanel) {
		
		funzione = new CanvasFunzione(editorTextPanel);
		funzione.setPreferredSize(new Dimension(2000, 50));
		sp = new JScrollPane(funzione);
		sp.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		
		addFS = new JButton("Fattore semplice");
		addFCC = new JButton("Fattore complesso");
		reset = new JButton("Reset");
		aggiorna = new JButton("Aggiorna");
		aggiorna.setEnabled(false);
		
		addFS.setSize(addFS.getPreferredSize());
		addFCC.setSize(addFCC.getPreferredSize());
		reset.setSize(reset.getPreferredSize());
		aggiorna.setSize(aggiorna.getPreferredSize());
		
		add(sp);
		add(addFS);
		add(addFCC);
		add(reset);
		add(aggiorna);
		
	}
	
	private void addActionListeners() {
		addFS.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				funzione.nuovoFattoreSemplice();
			}
		});
		
		addFCC.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(!UTIL.MESSAGGIO_NO_ASINT_PER_FCC_VISUALIZZATO){
					JOptionPane.showMessageDialog(null, "Attenzione: questa  una versione beta.\n" +
							"La funzione di tracciamento dei diagrammi asintotici per fattori complessi non  stata implementata.\n" +
							"Si pu visualizzare il grafico reale, ma il grafico asintotico non  corretto.\n" +
							"Nelle impostazioni  possibile disattivare la visualizzazione del grafico asintotico.");
					UTIL.MESSAGGIO_NO_ASINT_PER_FCC_VISUALIZZATO = true;
				}
				funzione.nuovoFattoreComplesso();
			}
		});
		
		reset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				funzione.reset();
			}
		});
		
		aggiorna.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		
		addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
				posizionaComponenti();
			}
		});
		
	}

	private void posizionaComponenti() {
		int supMargin = 20;
		int infMargin = 10;
		int orizMargin = 15;
		int interlinea = 5;
		
		int availW = getWidth() - orizMargin*2;
		int availH = getHeight() - (supMargin + infMargin);
		
		int hSP = availH - (addFS.getHeight() + interlinea);
		
		int ySP = supMargin;
		int yButtons = ySP + hSP + interlinea;
		
		sp.setBounds(orizMargin, ySP, availW, hSP);
		
		int x = orizMargin;
		addFS.setLocation(x, yButtons);
		x += addFS.getWidth();
		addFCC.setLocation(x, yButtons);
		x += addFCC.getWidth();
		reset.setLocation(x, yButtons);
		x += reset.getWidth();
		aggiorna.setLocation(x, yButtons);
		
	}


}






















