package gui.pannelliGestione;

import gui.ObserverParametriScala;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import app.UTIL;


@SuppressWarnings("serial")
public class PannelloControllo extends JPanel {

	private JLabel jlabel0;
	private JLabel jlabel1;
	private JLabel jlabel2;
	private JLabel jlabel3;
	private JLabel jlabel4;
	private JLabel jlabel5;
	private JSpinner faseMax;
	private JSpinner faseMin;
	private JSpinner moduloMax;
	private JSpinner moduloMin;
	private JSpinner numDec;
	private JSpinner pulsMin;
	
	private ObserverParametriScala observer;

	public PannelloControllo(ObserverParametriScala observer){
		super(null);
		this.observer=observer;
		setBorder(BorderFactory.createTitledBorder("Controllo parametri grafico"));
		
		inizializzaComponenti();
		configuraComponenti();
		posizionaComponenti();
		aggregaComponenti();
		configurazioneSpinner();
	}
	
	private void configurazioneSpinner(){
		
		SpinnerNumberModel faseMaxModel = new SpinnerNumberModel(
				UTIL.F_MAX_DEFAULT,
				UTIL.MINIMA_F_MAX,
				100000, 
				5);
		faseMax.setModel(faseMaxModel);
		
		SpinnerNumberModel faseMinModel = new SpinnerNumberModel(
				UTIL.F_MIN_DEFAULT,
				-100000, 
				UTIL.MASSIMA_F_MIN, 
				5);
		faseMin.setModel(faseMinModel);
		
		SpinnerNumberModel moduloMaxModel = new SpinnerNumberModel(
				UTIL.M_MAX_DEFAULT, 
				UTIL.MINIMO_M_MAX, 
				100000, 5);
		moduloMax.setModel(moduloMaxModel);
		
		SpinnerNumberModel moduloMinModel = new SpinnerNumberModel(
				UTIL.M_MIN_DEFAULT, 
				-100000, 
				UTIL.MASSIMO_M_MIN, 
				5);
		moduloMin.setModel(moduloMinModel);
		
		SpinnerNumberModel numDecModel = new SpinnerNumberModel(
				UTIL.LOGWMAX_DEFAULT-UTIL.LOGWMIN_DEFAULT, 
				1,
				100,
				1);
		numDec.setModel(numDecModel);
		
		SpinnerNumberModel pulsMinModel = new SpinnerNumberModel(
				UTIL.LOGWMIN_DEFAULT, 
				-50, 
				50, 
				1);
		pulsMin.setModel(pulsMinModel);
		
		ChangeListener cl = new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				updateObserverScalaGrafico();
			}
		};
		
		faseMax.addChangeListener(cl);
		faseMin.addChangeListener(cl);
		moduloMax.addChangeListener(cl);
		moduloMin.addChangeListener(cl);
		numDec.addChangeListener(cl);
		pulsMin.addChangeListener(cl);
	}
	
	public void updateObserverScalaGrafico(){
		observer.aggiornaScalaGrafico((Integer)numDec.getValue(), 
				(Integer)pulsMin.getValue(), 
				(Integer)faseMax.getValue(), 
				(Integer)faseMin.getValue(), 
				(Integer)moduloMax.getValue(), 
				(Integer)moduloMin.getValue());
	}
	

	//grafica -------------------------------------------------------

	private void inizializzaComponenti(){
		jlabel0 = new JLabel("Numero decadi:");
		jlabel1 = new JLabel("Pulsazione minima:");
		jlabel2 = new JLabel("Valore min modulo:");
		jlabel3 = new JLabel("Valore max modulo:");
		jlabel4 = new JLabel("Valore min fase:");
		jlabel5 = new JLabel("Valore max fase:");
		faseMax = new JSpinner();
		faseMin = new JSpinner();
		moduloMax = new JSpinner();
		moduloMin = new JSpinner();
		numDec = new JSpinner();
		pulsMin = new JSpinner();
	}


	private void configuraComponenti(){
		jlabel0.setHorizontalAlignment(SwingConstants.RIGHT);
		jlabel1.setHorizontalAlignment(SwingConstants.RIGHT);
		jlabel2.setHorizontalAlignment(SwingConstants.RIGHT);
		jlabel3.setHorizontalAlignment(SwingConstants.RIGHT);
		jlabel4.setHorizontalAlignment(SwingConstants.RIGHT);
		jlabel5.setHorizontalAlignment(SwingConstants.RIGHT);
	}


	private void posizionaComponenti(){
		int yMin = 10;
		int xMin = -10;
		jlabel0.setBounds(20+xMin, 20+yMin, 130, 20);
		jlabel1.setBounds(200+xMin, 20+yMin, 130, 20);
		jlabel2.setBounds(20+xMin, 50+yMin, 130, 20);
		jlabel3.setBounds(200+xMin, 50+yMin, 130, 20);
		jlabel4.setBounds(20+xMin, 80+yMin, 130, 20);
		jlabel5.setBounds(200+xMin, 80+yMin, 130, 20);
		faseMax.setBounds(335+xMin, 80+yMin, 50, 20);
		faseMin.setBounds(155+xMin, 80+yMin, 50, 20);
		moduloMax.setBounds(335+xMin, 50+yMin, 50, 20);
		moduloMin.setBounds(155+xMin, 50+yMin, 50, 20);
		numDec.setBounds(155+xMin, 20+yMin, 50, 20);
		pulsMin.setBounds(335+xMin, 20+yMin, 50, 20);
	}


	private void aggregaComponenti(){
		add(jlabel0);
		add(jlabel1);
		add(jlabel2);
		add(jlabel3);
		add(jlabel4);
		add(jlabel5);
		add(faseMax);
		add(faseMin);
		add(moduloMax);
		add(moduloMin);
		add(numDec);
		add(pulsMin);
	}
	
	

}
