package gui.pannelliGestione;

import gui.LinkLabel;

import java.awt.Desktop;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.net.URI;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

@SuppressWarnings("serial")
public class PannelloFunzione extends JPanel {
	
	private EditorGraficoPanel editorGrafico;
	private EditorTextPanel editorTesto;
	private LinkLabel guida;
	
	public PannelloFunzione() {
		super(null);
		setBorder(BorderFactory.createTitledBorder("Funzione di trasferimento"));
		
		editorTesto = new EditorTextPanel();
		editorGrafico = new EditorGraficoPanel(editorTesto);
		
		guida = new LinkLabel("Guida generale di BodeDiagramPlotter");
		guida.setFont(new Font("Arial", 0, 12));
		guida.setSize(guida.getPreferredSize());
		guida.setAction(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
//				JFrame f = new JFrame();
//				f.setBounds(PannelloFunzione.this.getBounds());
//				Guida.mostra(f);
				try{
					Desktop.getDesktop().browse(
							URI.create("http://javadevil.altervista.org/javaworks/bodediagramplotter.html"));
				}catch(Exception exc){
					JOptionPane.showMessageDialog(null, 
							"Errore imprevisto nell'apertura della pagina della guida.\n"+
							"Puoi visualizzare la guida manualmente sulla pagina\n" +
							"http://javadevil.altervista.org/javaworks/bodediagramplotter.html");
				}
			}
		});
		
		add(editorGrafico);
		add(editorTesto);
		add(guida);
		
		addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
				posizionaComponenti();
			}
		});
		
	}
	
	private void posizionaComponenti(){
		
		int supMargin = 20;
		int infMargin = 10;
		int orizMargin = 15;
		int interlinea = 15;
		
		int w = getWidth() - 2*orizMargin;
		int h = getHeight() - supMargin - infMargin;
		
		int hLabelGuida = guida.getPreferredSize().height;
		int availH = h - (interlinea + interlinea + hLabelGuida);
		int hEditors = availH/2;
		
		int yEditorGrafico = supMargin;
		int yEditorTesto = yEditorGrafico + hEditors + interlinea;
		int yLabelGuida = yEditorTesto + hEditors + interlinea;
		
		editorGrafico.setBounds(orizMargin, yEditorGrafico, w, hEditors);
		editorTesto.setBounds(orizMargin, yEditorTesto, w, hEditors);
		guida.setLocation(orizMargin + 5, yLabelGuida);
		
	}
	
	public String getFunzione() {
		return editorTesto.getText();
	}

}










