package gui.pannelliGestione.graphicsFdtElem;

import java.awt.Graphics2D;

public class GraphicFCC extends GraphicFattore {
	
	private double num1, den1;
	private double num2, den2;
	
	
	public GraphicFCC(int m) {
		super(m);
	}
	
	public GraphicFCC(int m, double num1, double den1, double num2, double den2) {
		super(m);
		setNum1(num1);
		setNum2(num2);
		setDen1(den1);
		setDen2(den2);
	}
	
	public double getNum1() {
		return num1;
	}
	public void setNum1(double num1) {
		this.num1 = num1;
	}
	public double getDen1() {
		return den1;
	}
	public void setDen1(double den1) {
		if(den1==0){
			throw new IllegalArgumentException("denominatore den1=0??");
		}
		this.den1 = den1;
	}
	public double getNum2() {
		return num2;
	}
	public void setNum2(double num2) {
		this.num2 = num2;
	}
	public double getDen2() {
		return den2;
	}
	public void setDen2(double den2) {
		if(den2==0){
			throw new IllegalArgumentException("denominatore den2=0??");
		}
		this.den2 = den2;
	}
	
	public String getTextA(){
		return segno1()+formatDouble(num1)+
			((den1!=1 && den1!=-1) ? "/"+formatDouble(den1) : "");
	}
	public String getTextB(){
		return segno2()+formatDouble(num2)+
			((den2!=1 && den2!=-1) ? "/"+formatDouble(den2) : "");
	}
	
	private String s1(){
		return "(";
	}
	private String s2(){
		return "1"+segno1();
	}
	private String s3Num(){
		return ""+formatDouble(num1);
	}
	private String s3Den(){
		return ""+formatDouble(den1);
	}
	private String s4(){
		return "s"+segno2();
	}
	private String s5Num(){
		return ""+formatDouble(num2);
	}
	private String s5Den(){
		return ""+formatDouble(den2);
	}
	private String s6(){
		return "s";
	}
	private String s7(){
		return "2";
	}
	private String s8(){
		return ")";
	}
	private String s9(){
		return formatDouble(m);
	}
	
	private String segno1() {
		if(num1<0){
			if(den1<0){
				return "+";
			}else{
				return "-";
			}
		}else{
			if(den1<0){
				return "-";
			}else{
				return "+";
			}
		}
	}
	
	private String segno2() {
		if(num2<0){
			if(den2<0){
				return "+";
			}else{
				return "-";
			}
		}else{
			if(den2<0){
				return "-";
			}else{
				return "+";
			}
		}
	}

	@Override
	public void paintElement(Graphics2D g, int x, int y) {
		if(Math.abs(den1)==1 && Math.abs(den2)==1){
			paintElementNoFract(g, x, y);
		}else{
			paintElementFract(g, x, y);
		}
		ultimaPosizione.setBounds(x, y, getW(), getH());
	}
	
	private void paintElementNoFract(Graphics2D g, int x, int y){
		//non  una frazione
		int yPar = y+MAIN_FONT_BASELINE - 2; //piccola correzione perla parentesi
		int yMain = y+MAIN_FONT_BASELINE;
		int yLittle = y + LITTLE_FONT_BASELINE;
		
		int xInc = x;
		
		// (
		g.setFont(MAIN_FONT);
		g.drawString(s1(), xInc, yPar);
		xInc += getStringW(s1(), MAIN_FONT);
		
		// 1+
		g.drawString(s2(), xInc, yMain);
		xInc += getStringW(s2(), MAIN_FONT);
		
		// num
		g.drawString(s3Num(), xInc, yMain);
		xInc += getStringW(s3Num(), MAIN_FONT);
		
		// s+
		g.drawString(s4(), xInc, yMain);
		xInc += getStringW(s4(), MAIN_FONT);
		
		// num
		g.drawString(s5Num(), xInc, yMain);
		xInc += getStringW(s5Num(), MAIN_FONT);
		
		// s
		g.drawString(s6(), xInc, yMain);
		xInc += getStringW(s6(), MAIN_FONT);

		// 2
		g.setFont(LITTLE_FONT);
		g.drawString(s7(), xInc, yLittle);
		xInc += getStringW(s7(), LITTLE_FONT);

		// )
		g.setFont(MAIN_FONT);
		g.drawString(s8(), xInc, yPar);
		xInc += getStringW(s8(), MAIN_FONT);
		
		if(m!=1 && m!=-1){
			g.setFont(LITTLE_FONT);
			g.drawString(s9(), xInc, yLittle);
		}
		
	}
	
	private void paintElementFract(Graphics2D g, int x, int y){
		
		int yMainNum = y + BIG_FONT_HEIGHT/2 -2;
		int yMainDen = y + BIG_FONT_HEIGHT/2 +MAIN_FONT_BASELINE;
		int yMainNorm = y + (BIG_FONT_HEIGHT-MAIN_FONT_HEIGHT)/2 +MAIN_FONT_BASELINE;
		
		int yBig = y + BIG_FONT_BASELINE - 4; //piccola correzione per le parentesi
		
		int yLittleNorm = yMainNorm - MAIN_FONT_BASELINE + LITTLE_FONT_BASELINE;
		int yLittleBig = y + LITTLE_FONT_BASELINE;
		
		int xInc = x;
		
		// (
		g.setFont(BIG_FONT);
		g.drawString(s1(), xInc, yBig);
		xInc += getStringW(s1(), BIG_FONT);
		
		// 1+
		g.setFont(MAIN_FONT);
		g.drawString(s2(), xInc, yMainNorm);
		xInc += getStringW(s2(), MAIN_FONT);
		
		if(Math.abs(den1)==1){
			//non  frazione
			// num
			g.drawString(s3Num(), xInc, yMainNorm);
			xInc += getStringW(s3Num(), MAIN_FONT);
		}else{
			// frazione
			xInc+=4;
			int fractLineW = Math.max(getStringW(s3Num(), MAIN_FONT),
					getStringW(s3Den(), MAIN_FONT)) + 4;
			int middleY = y+BIG_FONT_HEIGHT/2;
			g.drawLine(xInc, middleY, xInc+fractLineW, middleY);
			
			// num
			int xNum = xInc + (fractLineW - getStringW(s3Num(), MAIN_FONT))/2;
			g.drawString(s3Num(), xNum, yMainNum);
			
			// den
			int xDen = xInc + (fractLineW - getStringW(s3Den(), MAIN_FONT))/2;
			g.drawString(s3Den(), xDen, yMainDen);
			
			xInc += fractLineW+4;
		}
		
		// s+
		g.drawString(s4(), xInc, yMainNorm);
		xInc += getStringW(s4(), MAIN_FONT);
		
		if(Math.abs(den2)==1){
			//non  frazione
			// num
			g.drawString(s5Num(), xInc, yMainNorm);
			xInc += getStringW(s5Num(), MAIN_FONT);
		}else{
			// frazione
			xInc+=4;
			int fractLineW = Math.max(getStringW(s5Num(), MAIN_FONT),
					getStringW(s5Den(), MAIN_FONT)) + 4;
			int middleY = y+BIG_FONT_HEIGHT/2;
			g.drawLine(xInc, middleY, xInc+fractLineW, middleY);
			
			// num
			int xNum = xInc + (fractLineW - getStringW(s5Num(), MAIN_FONT))/2;
			g.drawString(s5Num(), xNum, yMainNum);
			
			// den
			int xDen = xInc + (fractLineW - getStringW(s5Den(), MAIN_FONT))/2;
			g.drawString(s5Den(), xDen, yMainDen);
			
			xInc += fractLineW+4;
		}
		
		// s
		g.drawString(s6(), xInc, yMainNorm);
		xInc += getStringW(s6(), MAIN_FONT);

		// 2
		g.setFont(LITTLE_FONT);
		g.drawString(s7(), xInc, yLittleNorm);
		xInc += getStringW(s7(), LITTLE_FONT);

		// )
		g.setFont(BIG_FONT);
		g.drawString(s8(), xInc, yBig);
		xInc += getStringW(s8(), BIG_FONT);
		
		if(m!=1 && m!=-1){
			g.setFont(LITTLE_FONT);
			g.drawString(s9(), xInc, yLittleBig);
		}
	}

	@Override
	public int getW() {
		if(Math.abs(den1)==1 && Math.abs(den2)==1){
			return 
				getStringW(s1(), MAIN_FONT) +
				getStringW(s2(), MAIN_FONT) +
				getStringW(s3Num(), MAIN_FONT) +
				getStringW(s4(), MAIN_FONT) +
				getStringW(s5Num(), MAIN_FONT) +
				getStringW(s6(), MAIN_FONT) +
				getStringW(s7(), LITTLE_FONT) +
				getStringW(s8(), MAIN_FONT) +
				((m!=1 && m!=-1) ? getStringW(s9(), LITTLE_FONT) : 0);
		}else{
			return 
				getStringW(s1(), BIG_FONT) +
				getStringW(s2(), MAIN_FONT) +
				Math.max(
						getStringW(s3Num(), MAIN_FONT),
						getStringW(s3Den(), MAIN_FONT)) + 4 + 8 + 
						//4  la lunghezza in piu rispetto al numero piu grande
						//8  2*4 che  lo spazio tra s2 e s4
				getStringW(s4(), MAIN_FONT) +
				Math.max(
						getStringW(s5Num(), MAIN_FONT),
						getStringW(s5Den(), MAIN_FONT)) + 4 + 8 + 
				getStringW(s6(), MAIN_FONT) +
				getStringW(s7(), LITTLE_FONT) +
				getStringW(s8(), BIG_FONT) +
				((m!=1 && m!=-1) ? getStringW(""+m, LITTLE_FONT) : 0);
		}
	}

	@Override
	public int getH() {
		if(Math.abs(den1)==1 && Math.abs(den2)==1){
			return MAIN_FONT_HEIGHT;
		}else{
			return BIG_FONT_HEIGHT;
		}
	}

}















