package gui.pannelliGestione.graphicsFdtElem;

import java.awt.Graphics2D;

public class GraphicFS extends GraphicFattore {
	
	private double num, den;
	
	public GraphicFS(int m) {
		super(m);
	}
	
	public GraphicFS(int m, double num, double den){
		super(m);
		if(den==0){
			throw new IllegalArgumentException("denominatore den=0??");
		}
		this.num=num;
		this.den=den;
	}
	
	public void setNum(double num) {
		this.num = num;
	}
	public void setDen(double den) {
		if(den==0){
			throw new IllegalArgumentException("denominatore den=0??");
		}
		this.den = den;
	}
	public double getNum() {
		return num;
	}
	public double getDen() {
		return den;
	}
	
	@Override
	public void paintElement(Graphics2D g, int x, int y) {
		if(Math.abs(den)==1){
			//non  una frazione
			int yPar = y+MAIN_FONT_BASELINE - 2; //piccola correzione perla parentesi
			int yMain = y+MAIN_FONT_BASELINE;
			
			int xStart = x;
			
			g.setFont(MAIN_FONT);
			g.drawString(sNoDen1(), xStart, yPar);
			xStart += getStringW(sNoDen1(), MAIN_FONT);
			
			g.drawString(sNoDen2(), xStart, yMain);
			xStart += getStringW(sNoDen2(), MAIN_FONT);
			
			g.drawString(sNoDen3(), xStart, yPar);
			xStart += getStringW(sNoDen3(), MAIN_FONT);
			
			if(m!=1 && m!=-1){
				g.setFont(LITTLE_FONT);
				g.drawString(formatDouble(m), xStart, y+LITTLE_FONT_BASELINE);
			}
			
		}else{
			// una frazione
			
			int yMain = y + (BIG_FONT_HEIGHT-MAIN_FONT_HEIGHT)/2 + MAIN_FONT_BASELINE;
			int yBig = y + BIG_FONT_BASELINE - 4; //piccola correzione "endogena" :)
			int yLittle = y + LITTLE_FONT_BASELINE;
			
			int xInc = x;
			
			// (
			g.setFont(BIG_FONT);
			g.drawString(s1(), xInc, yBig);
			xInc += getStringW(s1(), BIG_FONT);
			
			// 1+
			g.setFont(MAIN_FONT);
			g.drawString(s2(), xInc, yMain);
			xInc += getStringW(s2(), MAIN_FONT) + 4;
			
			//ora devo disegnare la lina di frazione
			int fractLineW = Math.max(getStringW(s3Num(), MAIN_FONT),
					getStringW(s3Den(), MAIN_FONT)) + 4;
			int middleY = y+BIG_FONT_HEIGHT/2;
			g.drawLine(xInc, middleY, xInc+fractLineW, middleY);
			
			//numeratore
			int xNum = xInc + (fractLineW - getStringW(s3Num(), MAIN_FONT))/2;
			g.setFont(MAIN_FONT);
			g.drawString(s3Num(), xNum, middleY-2);
			
			//denominatore
			int xDen = xInc + (fractLineW - getStringW(s3Den(), MAIN_FONT))/2;
			g.drawString(s3Den(), xDen, middleY+MAIN_FONT_BASELINE);
			xInc += fractLineW+4;
			
			// s
			g.drawString(s4(), xInc, yMain);
			xInc += getStringW(s4(), MAIN_FONT);
			
			// )
			g.setFont(BIG_FONT);
			g.drawString(s5(), xInc, yBig);
			xInc += getStringW(s5(), BIG_FONT);
			
			// m
			if(m!=1 && m!=-1){
				g.setFont(LITTLE_FONT);
				g.drawString(formatDouble(m), xInc, yLittle);
			}
			
		}
		ultimaPosizione.setBounds(x, y, getW(), getH());
	}
	
	private String sNoDen1(){
		return "(";
	}
	private String sNoDen2(){
		return "1"+segno()+formatDouble(num)+"s";
	}
	private String sNoDen3(){
		return ")";
	}
	
	private String s1(){
		return "(";
	}
	private String s2(){
		return "1"+segno();
	}
	private String s3Num(){
		return formatDouble(num);
	}
	private String s3Den(){
		return formatDouble(den);
	}
	private String s4(){
		return "s";
	}
	private String s5(){
		return ")";
	}
	
	private String segno() {
		if(num<0){
			if(den<0){
				return "+";
			}else{
				return "-";
			}
		}else{
			if(den<0){
				return "-";
			}else{
				return "+";
			}
		}
	}

	@Override
	public int getW() {
		if(Math.abs(den)==1){
			return 
				getStringW(sNoDen1(), MAIN_FONT) +
				getStringW(sNoDen2(), MAIN_FONT) +
				getStringW(sNoDen3(), MAIN_FONT) +
				((m!=1 && m!=-1) ? getStringW(""+m, LITTLE_FONT) : 0);
		}else{
			return getStringW(s1(), BIG_FONT) +
				getStringW(s2(), MAIN_FONT) +
				Math.max(
						getStringW(s3Num(), MAIN_FONT),
						getStringW(s3Den(), MAIN_FONT)) + 4 + 8 + 
						//4  la lunghezza in piu rispetto al numero piu grande
						//8  2*4 che  lo spazio tra s2 e s4
				getStringW(s4(), MAIN_FONT) +
				getStringW(s5(), BIG_FONT) +
				((m!=1 && m!=-1) ? getStringW(""+m, LITTLE_FONT) : 0);
		}
		
	}
	
	public String getTextA(){
		return segno()+formatDouble(num)+((den!=1 && den!=-1) ? "/"+formatDouble(den) : "");
	}

	@Override
	public int getH() {
		if(Math.abs(den)==1){
			return MAIN_FONT_HEIGHT;
		}else{
			return BIG_FONT_HEIGHT;
		}
	}
	
	

}
